RPM Support - Story #5402

As a developer, Package content allows ORDER_BY in postgres based on EVR comparisons
09/04/2019 04:29 PM - ggainey

Status: CLOSED - CURRENTRELEASE Start date:

Priority: Normal Due date:

Assignee: dalley % Done: 100%
Category: Estimated time: 0:00 hour
Sprint/Milestone: Pulp RPM 3.5.0

Platform Release: Tags:

Groomed: No Sprint:

Sprint Candidate: No Quarter:

Description

In order to be able to do things like ORDER BY (EVR) in postgres on the Package content unit, we need to have a type and a
comparison method available. Some examples of this include:

Debian:

® https://packages.debian.org/sid/postgresql-11-debversion

Spacewalk:

® https://qithub.com/spacewalkproject/spacewalk/blob/master/schema/spacewalk/postgres/class/evr_t.sql

* https://github.com/spacewalkproject/spacewalk/blob/master/schema/spacewalk/postgres/packages/rpm.pkb#L 194

VMaaS:

® https://github.com/RedHatinsights/vmaas/blob/master/database/vmaas_db_postgresqgl.sql#L8

We should probably adopt one of the existing methods for the Package model.

Related issues:
Blocks RPM Support - Story #5367: As a user, | can have a sync option that re... CLOSED - CURRENTRELEASE

Associated revisions

Revision ce6c3644 - 06/30/2020 08:47 PM - dalley
Add database support for comparing EVR

closes: #5402 https://pulp.plan.io/issues/5402

[nocoverage]

History

#1 - 09/04/2019 04:35 PM - bmbouter

- Subject changed from As Pulp3, | need to be able to do ORDER_BY in postgres based on EVR comparisons to As a developer, Package content
allows ORDER_BY in postgres based on EVR comparisons

- Description updated

Is the idea that there will be a field on the model and a DB trigger would populate it?

#2 - 09/04/2019 04:39 PM - ggainey

bmbouter wrote:
Is the idea that there will be a field on the model and a DB trigger would populate it?

Depends on the exact approach - VMaas, for example, creates the evr_t array and inserts it directly:

https://github.com/RedHatInsights/vmaas/blob/master/reposcan/database/package_store.py#L45

#3 - 09/04/2019 05:22 PM - bmbouter

ggainey wrote:
bmbouter wrote:

Is the idea that there will be a field on the model and a DB trigger would populate it?

Depends on the exact approach - VMaa$, for example, creates the evr_t array and inserts it directly:

https://github.com/RedHatInsights/vmaas/blob/master/reposcan/database/package_store.py#L45

| see thank you. So we could do it either way.

#4 - 02/25/2020 07:33 PM - ttereshc
- Priority changed from Normal to High

- Sprint/Milestone set to Priority items (outside of planned milestones/releases)

Priority is high assuming this is blocking support of "keep N versions of RPMs in a repo"

#5 - 02/25/2020 07:51 PM - ttereshc
- Blocked by Story #5950: Add database support for comparing EVRs added

#6 - 02/25/2020 07:52 PM - ttereshc

- Blocks Story #5367: As a user, | can have a sync option that retains the latest N packages of the same name added

#7 - 05/27/2020 06:35 PM - ttereshc

- Sprint/Milestone changed from Priority items (outside of planned milestones/releases) to Pulp 3.x RPM (Katello 4.1)
#8 - 05/27/2020 06:37 PM - ttereshc
- Priority changed from High to Normal

#9 - 06/22/2020 07:50 PM - dalley
- Blocked by deleted (Story #5950: Add database support for comparing EVRs)

#10 - 06/22/2020 07:50 PM - dalley
- Status changed from NEW to POST

- Assignee set to dalley
#11 - 07/02/2020 08:27 PM - dalley

- Status changed from POST to MODIFIED
- % Done changed from 0 to 100

Applied in changeset ce6c3644b2a912e37837e782b8c1aa02e157¢282.

#12 - 07/24/2020 07:13 PM - ttereshc
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE

#13 - 07/24/2020 07:17 PM - ttereshc
- Sprint/Milestone changed from Pulp 3.x RPM (Katello 4.1) to Pulp RPM 3.5.0
